function u_pred = DVine_predict(Param,n,paths,family,u)
% Prediction and simulation from heteroskedastic D-VInes copula with
% This function predicts the value of u at time t. if t =1 the predicted u
% are just random numbers between 0 and 1.
% components of mixture of t-s
switch family                                                              % Setting initial parameter values according to copula family
    case 't_mix'
    numpar = 5;
    case 'gumbel_mix'
    numpar = 5;
    case 't'
    numpar = 2;
end
lag = size(Param,2);
if nargin ==4   % Simulations
    h1 = rand(paths,lag);   %   [u1|u4 , u2|u4, u3|u4,  u4]      %lag = 4
    h2 = zeros(paths,lag);    %   [u5|u2 , u5|u3, u5|u4,  u5]
else         % Prediction
    [h1,h2] = hfunctions_t_multiple(u,Param(:)',family,numpar);
    paths = length(u);
end
u_pred = zeros(n,paths);

%  The objective is to simulate u5 according to Dvine.
for j = 1:n
    for i =1:lag
        if i==1
            h2(:,i) = invh2(rand(paths,1),h1(:,i),Param(:,lag-i+1),family);%rand(paths,1)
        elseif i>1
            h2(:,i) = invh2(h2(:,i-1),h1(:,i),Param(:,lag-i+1),family);
        end
    end
    % Update h1 = [u2|u5 , u3|u5, u4|u5,  u5]
    for i = 1:lag
        if i==lag
            h1(:,i) = h2(:,end);    %  Updating with u5 in order to simulate u6 in next step
        elseif i<lag
            h1(:,i) = hfunc(h1(:,i+1),h2(:,i+1),family,Param(:,lag-i));    %  Updating with u5 in order to simulate u6 in next step
        end
    end
    if mod(j,100)==0
       disp(['Predictions computed up to h = ' mat2str(j)]);
    end
    u_pred(j,:) = h2(:,end)';
    if strcmp(family,'Vsym')
        u_pred = (1-abs(2*u_pred-1));
    end
end