%-------------  Using VBDA on multivariate time series  ------------------%
clear
family = 'gumbel_mix';       %Copula family for pair-copula components    
p = 1;                       %D-Vine Markov order                         
k = 15;                      %Number of factors for covariance matrix     
S = 500;                     %Number of evaluations to compute gradient   
nVB = 5000;                  %Number of VB steps                          
VA = 2;                      %Variational Bayes approach for estimation     
[y,margintype] = pickdata('Homicide');    %Ordinal time series, change to your own data
r = size(y,2); 
mdist = cell(r,1);          %Marginal distribution of y                        
for i = 1:r                 %Change to your margins of choice              
    mdist{i} = fitdist(y(:,i),'NegativeBinomial'); 
end            
VBDAobj = VBDAfit_multi(y,margintype,mdist,family,p,k,S,nVB,VA);%Using VBDA 
[rsMean,rsQuant,rhoS] = VBDAspearman_multi(VBDAobj); %Spearman's rhos
VBDAplots(VBDAobj) %Producing plots from object VBDAobj
h = 8;
n = 10;
y_pred = VBDApredict(VBDAobj,h,n); %Predicting from VBDAobj h steps ahead