%-----------  Using VBDA on a univariate time series  --------------------%
clear
family = 'gumbel_mix';    %Copula family for pair-copula components
p = 3;                    %D-Vine Markov order
k = 3;                    %Number of factors for covariance matrix
S = 500;                  %Number of evaluations to compute gradient
nVB = 5000;               %Number of VB steps
y = pickdata('Logit');    %Ordinal time series, change to your own data
mdist = fitdist(y,'Binomial'); %Change to your own marginal density
VA = 2;                   %Variational Bayes approach for estimation  
VBDAobj = VBDAfit_uni(y,mdist,family,p,k,S,nVB,VA);%Using VBDA
VBDAplots(VBDAobj)        %Producing plots from object VBDAobj
[rhoSmean,rhoSquant,rhoS] = VBDAspearman_uni(VBDAobj); %Spearman's rhos
h = 8; n = 10;
y_pred = VBDApredict(VBDAobj,h,n); %Predicting from VBDAobj h steps ahead