%-------------------------------------------------------------------------%
%--- Using VBDA on multiple time series with many factor structures ------%
%-------------------------------------------------------------------------%
clear
%-------> Estimation
family = 'gumbel_mix';       %Copula family for pair-copula components    %
p = 1;                       %D-Vine Markov order                         %
S = 500;                     %Number of evaluations to compute gradient   %
nVB = 5000;                   %Number of VB steps                          %
VA = 3;                      %Variational Bayes approach for estimation   %    
example = 'Homicide';     
[y,type] = pickdata(example);%Ordinal time series, change to your own data%
r = size(y,2); 
mdist = cell(r,1);          %Marginal distribution of y                   %       
for i = 1:r                 %Change to your margins of choice             %
    mdist{i} = selectedDist(y(:,i),type{i}); 
end     
K = [0 1 2 4 5 10 15 40 50];
%-->  Fitting copula to y using VBDA
for k = K
    filename = ['wd_' example '_p' mat2str(p) '_k' mat2str(k) '_' family '_VA' mat2str(VA) '.mat'];
    rng(09021990)
    VBDAobj = VBDAfit_multi(y,type,mdist,family,p,k,S,nVB,VA,filename);
end
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%
%-------------------------------------------------------------------------%