%-------------------------------------------------------------------------%
%----- Using VBDA on single time series with many factor structures ------%
%-------------------------------------------------------------------------%
clear
%-------> Estimation
family = 'gumbel_mix';       %Copula family for pair-copula components    %
p = 3;                       %D-Vine Markov order                         %
S = 500;                     %Number of evaluations to compute gradient   %
nVB = 5000;                   %Number of VB steps                          %
example = 'Murder';     
y = pickdata(example);       %Ordinal time series, change to your own data%
mdist = selectedDist(y);     %Marginal distribution of y                  %
VA = 1;                      %Variational Bayes approach for estimation   %    
K = 15;
%-->  Fitting copula to y using VBDA
for k = 0:K
    filename = ['wd_' example '_p' mat2str(p) '_k' mat2str(k) '_' family '_VA' mat2str(VA) '.mat'];
    rng(09021990)
    VBDAobj = VBDAfit_uni(y,mdist,family,p,k,S,nVB,VA,filename);
end