function VBDAplots(VBDAobj)
[T,r] = size(VBDAobj.y);
if r ==1
    letters = {'(a)' '(b)' '(c)' '(d)' '(e)' '(f)' '(g)' '(h)' '(i)'};
    figure
    subplot(1,2,1)
    plot(1:length(VBDAobj.y),VBDAobj.y)
    ylabel('y_t')
    title(letters{1})
    xlim([0 length(VBDAobj.y)])
    subplot(1,2,2)
    histogram(VBDAobj.y,'Normalization','pdf')
    ylabel('Relative Frequency')
    xlabel('y')
    title(letters{2})
    figure
    s = 1;
    for k = 1:VBDAobj.p
        subplot(1,VBDAobj.p,k)
        mix_cop_plot(VBDAobj.gamma_mean((k-1)*5+1:(5*k)),[0.02 0.98],1,VBDAobj.family,true);
        title([letters{s} ' ' ': log c_' mat2str(k+1)])
        zlabel(['log(c_' mat2str(k+1) ')'])
        s = s+1;
    end
else
    letters = {'(a)' '(b)' '(c)' '(d)' '(e)' '(f)'};
    s = 1;
    for ts = 1:r
        subplot(r,2,2*ts-1)
        ynames = ['Variable ' mat2str(ts)];
        plot(1:T,VBDAobj.y(:,ts))
        xlim([1 T])
        title([letters{s} ' ' ynames])
        ylabel('y_t')
        xlabel('t')
        s = s+1;
        subplot(r,2,2*ts)
        histogram(VBDAobj.y(:,ts),'Normalization','pdf')
        xlim([0 max(VBDAobj.y(:,ts))])
        title([letters{s} ' ' ynames])
        ylabel('Relative Frequency')
        xlabel('y')
        s = s+1;
    end
    figure
    [~,Gamma] = q_lambda(VBDAobj.mu,[],50000,VBDAobj.family,VBDAobj.B,VBDAobj.D);
    muGamma = mean(Gamma);
    mix_cop_plot_DVine(muGamma,r,VBDAobj.p,[0.02 0.98],1,'gumbel_mix',true)
end
figure
plot(1:VBDAobj.nVB,VBDAobj.LB)
ylabel('Lower Bound')
xlabel('VB steps')
title('Lower Bound')