function M = calcFnu(u,Param,Copula_choice) 
t = size(u,1);   % Number of time observations
m = size(u,2);   % Number of variables
ut = u';
ut = ut(:);      % arranging u's as a vector (u1 v1 w1 u2 v2 w2 ,..., uT vT wT)';
p = size(Param,3)-1;
N = m*t;
M = spdiags(ut,0,m*t,m*t);  % h functions matrix.
h1_new = [];    
h2_new = [];    % Auxilary vectors to stack information in parfor
temp_1 = zeros(1,N-1);
temp_2 = zeros(1,N-1);
J = []; 
for r = 1:((p+1)*m-1)   % Band or tree
     h1 = diag(M,-r+1);
     h2 = diag(M,r-1);
     for i = (r+1):min((m+r),m*(p+1))  % Copula in band or tree that can be parallelized
         I = (i:m:N);  % Indexes for all the h functions to evaluate in the same copula
         j = I-r;s = ceil(j(1)/m);t=ceil(I(1)/m);k = t-s;l1 =I(1)-m*(t - 1);l2 =j(1)-m*(s-1);
         u1 = full(h1(I-r+1));
         u2 = full(h2(j));
         copula = Copula_choice{l1,l2,k+1};Par = Param(l1,l2,k+1,:);
         h1_new = [h1_new hfunc(u1,u2,copula,Par,2)'];   % Parfor works with stacking but not storing   %Lower
         h2_new = [h2_new hfunc(u2,u1,copula,Par,1)'];                                                  %Upper
         J = [J j];  % Since j is not evaluated in order anymore is necessary to re-arrange the vector
     end
   temp_1(J) = h1_new;
   temp_2(J) = h2_new;
   M = M + spdiags(temp_1(:),-r,N,N)+spdiags(temp_2(:),-r,N,N)';
   h1_new = [];
   h2_new = [];
   temp_1 = zeros(1,N-1-r);
   temp_2 = zeros(1,N-1-r);
   J = [];
 end


















