function grad_lambda = grad_lambda_logq(theta,z,lambda,k,T,VA)
persistent indPositiveC REPmat id1 id2 IT2 IT Kcom;    % Only has to be loaded the first time for this function, after that it stays in the system
S = size(theta,1);
d = size(theta,2);
[mu,Sigma,B,D,muz,logsigmaz,C] = lambda2musigma(lambda,d,T,k,VA);
Dm2 = sparse(1:d,1:d,1./(diag(D).^2),d,d);
Sigmainv = Dm2-Dm2*B/(sparse(1:k,1:k,1,k,k)+B'*Dm2*B)*B'*Dm2;
SigmainvB = Sigmainv*B;
SigmainvD = Sigmainv*D;
Term1 = (theta-repmat(mu',S,1))';
dmu = Sigmainv*Term1;
dB = zeros(size(B2vechB(B,k),1),S);
dD = zeros(size(Sigma,1),S);
for s = 1:S
    dBtemp = -SigmainvB+Sigmainv*(theta(s,:)'-mu)*(theta(s,:)'-mu)'*SigmainvB;
    dB(:,s) = B2vechB(dBtemp,k);
    dD(:,s) = diag(-SigmainvD+Sigmainv*(theta(s,:)'-mu)*(theta(s,:)'-mu)'*SigmainvD);
end
if VA == 1
    dmuz = [];
    dlogsigmaz = [];
    dC = [];
elseif VA == 2
    sigma2 = exp(2*logsigmaz);
    sigma2rep = repmat(sigma2,1,S);
    muZ = repmat(muz,1,S);
    dlogsigmaz = -1+(1./sigma2rep).*(z-muZ).^2;
    dmuz = (1./sigma2rep).*(z-muZ);
    dC = [];
elseif VA == 3
    if isempty(indPositiveC) || isempty(id1) || isempty(id2) || isempty(IT2) || isempty(IT) || isempty(Kcom)
        PositiveC = diag(ones(T,1))+diag(ones(T-1,1),-1);
        indPositiveC = (PositiveC(:)==1);
        [ind1,ind2] = meshgrid(1:T,1:T);
        id1 = ind1(:)';
        id2 = ind2(:)';
        IT2 = sparse(1:T^2,1:T^2,1);
        IT = sparse(1:T,1:T,1);
        Kcom = communtationM(IT);
    end
    Cinvt = inv(C)';
    muZ = repmat(muz,1,S);
    zMmuzt = (z-muZ)';
    zMmuzKronzMmuz = zMmuzt(:,id1).*zMmuzt(:,id2);
    dSigmaInvdC = (IT2+Kcom)*kron(C,IT);
    dC = repmat(Cinvt(:)',S,1)-0.5*zMmuzKronzMmuz*dSigmaInvdC;
    dC = dC(:,indPositiveC);
    dC = dC';
    dmuz = (zMmuzt*C)*C';
    dmuz = dmuz';
    dlogsigmaz = [];
end
grad_lambda = [dmu; dB; dD; dmuz; dlogsigmaz;dC];