function [g_lambda_L,loghhat,log_theta,log_q_lambda,g_lambda_logq] = gradient_computeM(theta,gamma,u,z,ai,bi,Copula_choice,lambda,k,p,VA,ait,bit,ct)
n = size(theta,2);                                                          %Number of copula parameters
[~,r] = size(ai);
S = size(u,2);
numelait = length(ait);
[mu,Sigma,~,~,muz,logsigmaz,C] = lambda2musigma(lambda,n,numelait,k,VA);
Param = Gamma2Param(gamma,r,p);
loghhat = DVine_llParalelMulti(ai,bi,Param,Copula_choice,u);
log_theta = sum(log(0.995)-theta-2*log(exp(-theta)+1),2)';                  %Implied by uniform on gamma
log_q_lambda =  log_mvnpdf(theta',repmat(mu,1,S),Sigma)';
if  VA == 1
    log_q_u = repmat(sum(-log(bit-ait)),1,S);
elseif VA ==2
    Ai = repmat(ait,1,S);
    Bi = repmat(bit,1,S);
    sigmaz2 = repmat(exp(2*logsigmaz),1,S);
    muZ = repmat(muz,1,S);
    log_q_u = sum(-0.5*log(2*pi*sigmaz2)-0.5*(1./(sigmaz2)).*(z-muZ).^2-log(Bi-Ai)+0.5*log(2*pi)+0.5*z.^2);
elseif VA == 3
    Ai = repmat(ait,1,S);
    Bi = repmat(bit,1,S);
    muZ = repmat(muz,1,S);
    zMmuztC = (z-muZ)'*C;
    log_q_u = -(numelait/(2))*log(2*pi)+log(abs(det(C)))-0.5*sum(zMmuztC.*zMmuztC,2)'+sum(-log(Bi-Ai)+0.5*log(2*pi)+0.5*z.^2);
end
log_q_lambda = log_q_lambda + log_q_u;
g_lambda_logq = grad_lambda_logq(theta,z,lambda,k,numelait,VA);
nLambda = size(g_lambda_logq,1);
g_lambda_L = [];
if ~isempty(ct)
    g_lambda_L = zeros(nLambda,1);
    for i = 1:nLambda
        g_lambda_L(i) = mean((loghhat+log_theta-log_q_lambda-ct(i)).*g_lambda_logq(i,:));
    end
end
