function log_theta = logpri(theta,family)
if strcmp(family,'gumbel_mix')
log_theta = sum(log(0.995)-theta-2*log(exp(-theta)+1),2)';        %Implied by uniform on gamma
end
if strcmp(family,'t')
ThetaNus = theta(:,2:2:end);   %Thetas corresponding to colums of nu
Thetarhos = theta(:,1:2:end);  %Thetas corresponding to colums of rho
Nus = ((40-0.03)./(exp(-ThetaNus)+1))+0.03;                                 %going from theta to nu
rhos = ((0.995-(-0.995))./(exp(-Thetarhos)+1))+(-0.995);                    %going from theta to rho
nu_prior = makedist('Exponential',10);
rhoPri = @(rho) log(1/pi)-0.5*log(1-rho.^2);                                    %Prior distribution of rhos: implied by uniform on Kendall's tau
nuPri = @(nu) log(pdf(nu_prior,nu).*(1./(cdf(nu_prior,40)-cdf(nu_prior,0.03))));%Prior distribution of nus: truncated exponential with mean 10
NusLogPri = nuPri(Nus);
rhosLogPri = rhoPri(rhos);
NusLogGrad = log(40-0.03)-ThetaNus-2*log(exp(-ThetaNus)+1);                 %Gradient to compute implied priors on theta
rhosLogGrad = log(0.995-(-0.995))-Thetarhos-2*log(exp(-Thetarhos)+1);
ThetaNusLogPri = NusLogPri+NusLogGrad;
ThetarhosLogPri = rhosLogPri+rhosLogGrad;
log_theta = sum([ThetaNusLogPri ThetarhosLogPri],2)';
end
