function [theta,T_theta] = q_lambda(mu,Sigma,S,family,B,D)
npar = length(mu);
if strcmp(family,'gumbel_mix')
    UB = 0.99*ones(S,npar);
    LB = zeros(S,npar);
end
if strcmp(family,'t')
    lag = npar/2;
    UB = repmat(repmat([0.99 40],1,lag),S,1);
    LB = repmat(repmat([-0.99 0.03],1,lag),S,1);
end
if nargin == 4
    target.mu = mu';
    target.chol = chol(Sigma);
    target.M = S;
    target.Dims   = length(mu);
    theta = q_mvnrnd(target);
elseif nargin == 6
    k = size(B,2);
    z = randn(k,S);
    eps = randn(npar,S);
    theta = repmat(mu,1,S)+B*z+D*eps;
    theta = theta';
end
T_theta = (UB-LB)./(exp(-theta)+1)+LB;

