function spr = spearmanDC(y)  %First Variable is discrete and Second Variable is continous.
m = size(y,2);
if (m~=2)
    error('This functions only admits two variables (Discrete, Continous). Vector y must have two columns.')
end
T = size(y,1);
cdftemp = cell(m,1);
pdftemp = cell(m,1);
x = cell(m,1);
Size = zeros(1,m);
[cdftemp{1,1},x{1,1}] = ecdf(y(:,1));
pdftemp{1,1} = diff(cdftemp{1,1});
Size(1) = length(x{1,1});
[~,x{2,1}] = ecdf(y(:,2));
Size(2) = length(x{2,1});
c_joint = reshape(zeros(prod(Size),1),Size);
[I,yI] = meshgrid(x{1,1},y(:,1));
LessThan  = yI<=I;
xitemp = x{2};
parfor j = 2:Size(2)
    c_joint(:,j) = sum(LessThan.*(repmat(y(:,2)<=xitemp(j),1,length(x{1,1}))))'/T;
end
c_joint(1,:) = 0;
f1 = pdftemp{1};
ECipCim1 = mean(c_joint(2:end,:) + c_joint(1:end-1,:),2);
spr = -3+sum(ECipCim1.*f1)*6;