function spr = spearmanDD(y)
m = size(y,2);
if (m~=2)
    error('This functions only admits two discrete variables. Vector y must have two columns.')
end
T = size(y,1);
cdf = cell(m,1);
pdf = cell(m,1);
x = cell(m,1);
Size = zeros(1,m);
for i = 1:m
    [cdf{i,1},x{i,1}] = ecdf(y(:,i));
    pdf{i,1} = diff(cdf{i,1});
    Size(i) = length(x{i,1});
end
c_joint = reshape(zeros(prod(Size),1),Size);
for element = 1:numel(c_joint)
    [i,j] = ind2sub(Size,element);  
    Indexes = [i,j];
    xtemp = [];
    if all(Indexes(1:m)~=1)
        for var = 1:m
            xitemp = x{var};
            xtemp = [xtemp xitemp(Indexes(var))];
        end
        c_joint(i,j) = sum(prod(y<=repmat(xtemp,T,1),2))/T;
    end
end
f1 = pdf{1};
f2 = pdf{2};
E_HHHH = 0;
for i = 2:Size(1)
    for j = 2:Size(2)
        E_HHHH = E_HHHH+ sum(c_joint(i,j)+c_joint(i,j-1)+c_joint(i-1,j)+c_joint(i-1,j-1))*f1(i-1)*f2(j-1);
    end
end
spr = -3+3*E_HHHH;
